# A Small, Evil little RDB reader.  Don't Use It.

package RDB::Lite;

use IO::File;

sub new
{
    my ( $class, $file ) = @_;

    my $self = { file => $file };

    bless $self, $class;

    $self->open;

    return $self;
}

sub open
{
    my ( $self ) = @_;

    my $fh = $self->{fh} = IO::File->new( $self->{file} )
	or die( "error opening $self->{file}\n" );

    my $cols;

    # skip comments
    1 while ( ($cols = $fh->getline) && $cols =~ /^\#/ );

    # grab header
    chomp( $cols );
    chomp( my $defs = <$fh> );

    $self->{cols} = [ split("\t", $cols ) ];
}

sub read
{
    my ( $self ) = @_;

    my $rec = $self->{fh}->getline
      or return;

    chomp $rec;
    my %data;
    @data{ @{$self->{cols}} } = split( "\t", $rec );

    return \%data;
}

sub match
{
    my ( $self, %match ) = @_;

    my @match_cols = grep { exists $match{$_} } @{$self->{cols}};
    my $must_match = @match_cols;

    while ( my $data = $self->read )
    {
	my $matches = grep { $data->{$_} eq $match{$_} } @match_cols;
	
	return $data if $matches == $must_match;
    }

    die( "unable to match record: %match\n" );
}


sub close
{
    my ( $self ) = @_;

    if ( exists $self->{fh} )
    {
	my $ok = $self->{fh}->close();
	delete $self->{fh};
	die( "error closing $self->{file}\n" )
	  unless $ok;
    }

}

sub DESTROY {}

sub match_record
{
    my ( $file, %match ) = @_;

    my $rdb = RDB::Lite->new( $file );

    return $rdb->match( %match );
}


1;
